Debian Bug report logs - #550497
xterm: Xft packed fonts are excessively wide

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Jed Davis <jld@panix.com>

Date: Sat, 10 Oct 2009 17:00:01 UTC

Severity: normal

Found in version xterm/249-1

Fixed in version xterm/250-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#550497; Package xterm. (Sat, 10 Oct 2009 17:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jed Davis <jld@panix.com>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sat, 10 Oct 2009 17:00:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jed Davis <jld@panix.com>
To: submit@bugs.debian.org
Subject: xterm: Xft packed fonts are excessively wide
Date: Sat, 10 Oct 2009 12:42:39 -0400
Package: xterm
Version: 249-1

[This was initially reported as a comment on bug #549953, but as it
appears to be a separate issue, I'm filing a new bug for it.]

The "Packed Font" option, added in xterm 249 and enabled by default,
causes certain fonts -- e.g., "DejaVu Sans Mono:pixelsize=10" -- to be
displayed with a larger character width than normal.  Disabling the
option with the X resource "*forcePackedFont:false", or interactively
through the C-mouse3 menu, restores the previous (and expected)
behavior.

The width in question is computed by the checkXft routine in
fontutils.c; a field named "min_width" is set to the *maximum* width of
characters in the ranges 32..127 and 159..255.  In the case of DejaVu
Sans Mono, characters 0xD8 and 0xF8 (uppercase and lowercase "o with
stroke") are wider than the others; they are also wider than the font's
reported maximum width, which is what is used in the non-packed case.

In addition to the X resource workaround described above, changing line
1567 of fontutils.c by replacing 256 with 128 is also effective.





Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#550497; Package xterm. (Sun, 11 Oct 2009 19:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Sun, 11 Oct 2009 19:03:06 GMT) Full text and rfc822 format available.

Message #10 received at 550497@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 550497@bugs.debian.org
Cc: 550497-submitter@bugs.debian.org
Subject: re: #550497 xterm: Xft packed fonts are excessively wide
Date: Sun, 11 Oct 2009 14:49:20 -0400
[Message part 1 (text/plain, inline)]
I think this change (which works for the case reported) is more in line
with what I'm trying to do.  The problem with just using the max-advance
property is that for fonts with a mixture of single- and double-column
glyphs, there's no reliable way to get the width of a single-column glyph.

So I did the scan in checkXft to get a "good" estimate.  (It's not perfect,
which is why I added the menu entry, etc).

diff -u -r1.314 fontutils.c
--- fontutils.c 2009/09/30 09:37:45     1.314 
+++ fontutils.c 2009/10/11 18:43:18 
@@ -1,4 +1,4 @@ 
-/* $XTermId: fontutils.c,v 1.314 2009/09/30 09:37:45 tom Exp $ */ 
+/* $XTermId: fontutils.c,v 1.315 2009/10/11 18:43:18 tom Exp $ */ 
 
 /************************************************************
 
@@ -1571,7 +1571,7 @@ 
            XGlyphInfo extents;
 
            XftTextExtents32(XtDisplay(xw), xft, &c, 1, &extents);
-           if (width < extents.width) 
+           if (width < extents.width && extents.width <= data->map.max_width) 
                width = extents.width;
        }
     }


-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to Jed Davis <jld@panix.com>:
Bug#550497. (Sun, 11 Oct 2009 19:03:12 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#550497; Package xterm. (Mon, 12 Oct 2009 01:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Mon, 12 Oct 2009 01:09:02 GMT) Full text and rfc822 format available.

Message #18 received at 550497@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 550497@bugs.debian.org
Cc: 550497-submitter@bugs.debian.org
Subject: re: #550497 xterm: Xft packed fonts are excessively wide
Date: Sun, 11 Oct 2009 21:00:28 -0400
[Message part 1 (text/plain, inline)]
...also, the limits checked on the continue statement aren't right
(which I found on investigating further).  It seems that Xft (or
the fonts) gives bogus values for extents of control-characters.

Fixing the limits seems to improve things - will make #250 once
I'm done with regression builds...

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Message sent on to Jed Davis <jld@panix.com>:
Bug#550497. (Mon, 12 Oct 2009 01:09:04 GMT) Full text and rfc822 format available.

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Tue, 13 Oct 2009 19:03:20 GMT) Full text and rfc822 format available.

Notification sent to Jed Davis <jld@panix.com>:
Bug acknowledged by developer. (Tue, 13 Oct 2009 19:03:20 GMT) Full text and rfc822 format available.

Message #26 received at 550497-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 550497-close@bugs.debian.org
Subject: Bug#550497: fixed in xterm 250-1
Date: Tue, 13 Oct 2009 18:32:58 +0000
Source: xterm
Source-Version: 250-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_250-1.diff.gz
  to pool/main/x/xterm/xterm_250-1.diff.gz
xterm_250-1.dsc
  to pool/main/x/xterm/xterm_250-1.dsc
xterm_250-1_amd64.deb
  to pool/main/x/xterm/xterm_250-1_amd64.deb
xterm_250.orig.tar.gz
  to pool/main/x/xterm/xterm_250.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 550497@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 13 Oct 2009 20:20:08 +0200
Source: xterm
Binary: xterm
Architecture: source amd64
Version: 250-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 542434 550368 550497
Changes: 
 xterm (250-1) unstable; urgency=low
 .
   * New upstream release
     + add check and error-message for fonts that have no printable values in
       the ISO-8859-1 range (closes: #542434)
     + limit minimum cell-width for packed font to maximum-advance
       reported by Xft.  Some fonts are wider than that, even in the Latin-1
       range (closes: #550497)
     + correct off-by-one in okPosition fix from patch #249 limit-checks which
       prevented double-click selection on the bottom line of the screen
       (closes: #550368)
     + document in xterm manpage the limited availability of resources color16
       to color255 as noted in patch #188 (LP: #438850)
Checksums-Sha1: 
 be1a62296213dfaae7f1712ed0ec0862662205a5 1314 xterm_250-1.dsc
 bf72e4ab4f6f7aeb27db9667df4a85e151546c90 889052 xterm_250.orig.tar.gz
 12a1524913a9a21251a8e244b01c3226b3bb93ca 72392 xterm_250-1.diff.gz
 1e3c008913e91fd1212ac77d056807caaa6f47c1 513502 xterm_250-1_amd64.deb
Checksums-Sha256: 
 95e8f6e8801f2d73d0191a3e2f051a4aa6302f31445f5003807a068d83ac1490 1314 xterm_250-1.dsc
 2dfdf63135f838d3ad11584f0da18360f993305733df4df3255b952067b4fb28 889052 xterm_250.orig.tar.gz
 bce3db714ed42e9e1402ba3bdfb0a4de0751625c07ea222cd097de77e62edd7b 72392 xterm_250-1.diff.gz
 a9a1283f55a6272bcd92849575b76fc7c1ab829b76d5f442a3adccb420137bde 513502 xterm_250-1_amd64.deb
Files: 
 4647cb0a6878afcb08379620a3ab9e20 1314 x11 optional xterm_250-1.dsc
 962ce117f65daf6bf376b6697b2cd02d 889052 x11 optional xterm_250.orig.tar.gz
 f438e69226e66cba95ce131c92ade16d 72392 x11 optional xterm_250-1.diff.gz
 5859dea85eaeb87b2d8038d2c32bff80 513502 x11 optional xterm_250-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkrUxqcACgkQmEvTgKxfcAwmsACdGYnL540Ld/C79tIOl/BK5C9f
kt4An0E2MbrTN0AcWxtGd8246SxzCsSc
=vfhN
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 16 Nov 2009 07:47:50 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:55:39 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.